package cn.com.infosec.jce.provider;

import cn.com.infosec.crypto.params.AsymmetricKeyParameter;
import cn.com.infosec.crypto.params.DHParameters;
import cn.com.infosec.crypto.params.DHPrivateKeyParameters;
import cn.com.infosec.crypto.params.DHPublicKeyParameters;
import java.math.BigInteger;
import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import javax.crypto.interfaces.DHPrivateKey;
import javax.crypto.interfaces.DHPublicKey;

public class DHUtil {
   public static AsymmetricKeyParameter generatePublicKeyParameter(PublicKey key) {
      if (key instanceof DHPublicKey) {
         DHPublicKey key1 = (DHPublicKey)key;
         BigInteger var10002 = key1.getY();
         BigInteger var10005 = key1.getParams().getP();
         DHPublicKey var10006 = key1;
         BigInteger key2 = key1.getParams().getG();
         int var1 = var10006.getParams().getL();
         return new DHPublicKeyParameters(var10002, new DHParameters(var10005, key2, (BigInteger)null, var1));
      } else {
         throw new InvalidKeyException("can't identify DH public key.");
      }
   }

   public static AsymmetricKeyParameter generatePrivateKeyParameter(PrivateKey key) {
      if (key instanceof DHPrivateKey) {
         DHPrivateKey key1 = (DHPrivateKey)key;
         BigInteger var10002 = key1.getX();
         BigInteger var10005 = key1.getParams().getP();
         DHPrivateKey var10006 = key1;
         BigInteger key2 = key1.getParams().getG();
         int var1 = var10006.getParams().getL();
         return new DHPrivateKeyParameters(var10002, new DHParameters(var10005, key2, (BigInteger)null, var1));
      } else {
         throw new InvalidKeyException("can't identify DH private key.");
      }
   }
}
